#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

/* Klasse fuer Funktionsobjekte, die den Mittelwert bilden
 */
class MittelwertOP {
  private:
    int anz;    // Anzahl aller Elemente
    int sum;    // Summe der Werte aller Elemente
  public:
    // Konstruktor
    MittelwertOP () : anz(0), sum(0) {
    }

    // Element aufnehmen
    void operator() (int elem) {
        anz++;
        sum += elem;
    }

    // Mittelwert durch Verwendung als float liefern
    operator float() {
        return static_cast<float>(sum) / static_cast<float>(anz);
    }
};

int main()
{
    vector<int> menge;

    /* Elemente 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge.push_back(i);
    }

    /* Mittelwert bilden
     */
    float mw = for_each (menge.begin(), menge.end(), MittelwertOP());

    /* und ausgeben
     */
    cout << "Mittelwert: " << mw << endl;
}
