#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include "PRINT.h"
using namespace std;

bool lessLength (const string& s1, const string& s2)
{
    return s1.length() < s2.length();
}

int main()
{
    vector<string> menge1;
    vector<string> menge2;

    /* beide Mengen mit den gleichen Strings fuellen
     */
    menge1.push_back ("1xxx");
    menge1.push_back ("2x");
    menge1.push_back ("3x");
    menge1.push_back ("4x");
    menge1.push_back ("5xx");
    menge1.push_back ("6xxxx");
    menge1.push_back ("7xx");
    menge1.push_back ("9xxx");
    menge1.push_back ("9xx");
    menge1.push_back ("10xxx");
    menge1.push_back ("11xxxx");
    menge1.push_back ("12");
    menge1.push_back ("13");
    menge1.push_back ("14xx");
    menge1.push_back ("15");
    menge1.push_back ("16");
    menge1.push_back ("17");
    copy (menge1.begin(), menge1.end(),
          back_inserter(menge2));

    PRINT ("vorher:\n ", menge1);
    PRINT (" ", menge2);

    /* Menge mit sort() sortieren
     *  - es wird nur anhand der Anzahl der Zeichen sortiert
     *  - bei gleicher Anzahl ist die Reihenfolge unerheblich
     */
    sort (menge1.begin(), menge1.end(),
          lessLength);

    /* Menge mit stable_sort() sortieren
     *  - es wird nur anhand der Anzahl der Zeichen sortiert
     *  - bei gleicher Anzahl bleibt die alte Reihenfolge erhalten
     */
    stable_sort (menge2.begin(), menge2.end(),
                 lessLength);

    PRINT ("mit sort():\n ", menge1);
    PRINT ("mit stable_sort():\n ", menge2);
}
