#include <cstdio>
#include <streambuf>
#include <iostream>
using namespace std;

extern "C" {
    int write (int fd, const char* buf, int anz);
}

class fdoutbuf : public streambuf {
  protected:
    int fd;    // Datei-Deskriptor
  public:
    // Konstruktor
    fdoutbuf (int _fd) : fd(_fd) {
    }
  protected:
    /* ein Zeichen ausgeben
     */
    virtual int_type overflow (int_type c) {
        if (c != EOF) {
            char z = c;
            if (write (fd, &z, 1) != 1) {
                return EOF;
            }
        }
        return c;
    }
    /* mehrere Zeichen ausgeben
     */
    virtual streamsize xsputn (const char* s, streamsize anz) {
        return write (fd, s, anz);
    }
};

class fdostream : public ostream {
  protected:
    fdoutbuf buf;
  public:
    fdostream (int fd) : buf(fd), ostream(&buf) {
    }
};
