#include <iostream>
#include <valarray>
using namespace std;

/* Valarray zeilenweise ausgeben
 *  - "size" war frueher "length"
 */
template<class T>
void printValarray (const valarray<T>& va, int anz)
{
    for (int i=0; i<va.size()/anz; i++) {
        for (int j=0; j<anz; j++) {
            cout << va[i*anz+j] << ' ';
        }
        cout << endl;
    }
    cout << endl;
}

int main()
{
    /* Valarray fuer 4 Zeilen mit 3 Spalten
     */
    valarray<double> va(12);

    for (int i=0; i<12; i++) {
        va[i] = i;
    }

    printValarray (va, 3);

    va[slice(0,4,3)] = pow (va[slice(1,4,3)], va[slice(2,4,3)]);

    printValarray (va, 3);

    /* Valarray mit dreimal dem Wert des dritten Elements
     * von va anlegen
     */
    valarray<double> vb(va[slice(2,4,0)]);

    /* Elemente mit diesem Wert ausmultiplizieren
     */
    va[slice(2,4,3)] *= vb;

    printValarray (va, 3);

    /* Quadratwurzel der Elemente in der zweiten Zeile ausgeben
     */
    printValarray ((valarray<double>)sqrt(va[slice(3,3,1)]), 3);
}
